// Package accesscontrolpolicyapi provides primitives to interact with the openapi HTTP API.
//
// Code generated by github.com/deepmap/oapi-codegen version v1.10.1 DO NOT EDIT.
package accesscontrolpolicyapi

import (
	externalRef0 "oransc.org/nonrtric/capifcore/internal/common29122"
	externalRef1 "oransc.org/nonrtric/capifcore/internal/common29571"
)

// Represents the access control policy list for a published service API.
type AccessControlPolicyList struct {
	// Policy of each API invoker.
	ApiInvokerPolicies *[]ApiInvokerPolicy `json:"apiInvokerPolicies,omitempty"`
}

// Represents the policy of an API Invoker.
type ApiInvokerPolicy struct {
	// The time ranges during which the invocations are allowed on the service API by the API invoker.
	AllowedInvocationTimeRangeList *[]TimeRangeList `json:"allowedInvocationTimeRangeList,omitempty"`

	// Invocations per second allowed on the service API by the API invoker.
	AllowedInvocationsPerSecond *int `json:"allowedInvocationsPerSecond,omitempty"`

	// Total number of invocations allowed on the service API by the API invoker.
	AllowedTotalInvocations *int `json:"allowedTotalInvocations,omitempty"`

	// API invoker ID assigned by the CAPIF core function
	ApiInvokerId string `json:"apiInvokerId"`
}

// Represents the time range during which the invocation of a service API is allowed by the API invoker.
type TimeRangeList struct {
	// string with format "date-time" as defined in OpenAPI.
	StartTime *externalRef0.DateTime `json:"startTime,omitempty"`

	// string with format "date-time" as defined in OpenAPI.
	StopTime *externalRef0.DateTime `json:"stopTime,omitempty"`
}

// GetAccessControlPolicyListServiceApiIdParams defines parameters for GetAccessControlPolicyListServiceApiId.
type GetAccessControlPolicyListServiceApiIdParams struct {
	// Identifier of the AEF
	AefId string `json:"aef-id"`

	// Identifier of the API invoker
	ApiInvokerId *string `json:"api-invoker-id,omitempty"`

	// To filter irrelevant responses related to unsupported features
	SupportedFeatures *externalRef1.SupportedFeatures `json:"supported-features,omitempty"`
}
